﻿@model eCommerce.Services.Model.Order
@using eCommerce.Services.Model
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Ventas";
    Layout = "~/Views/Shared/_Layout.cshtml";

    List<Stock> stocks = null;
    if (TempData["Stocks"] != null)
    {
        stocks = (List<Stock>)TempData["Stocks"];
    }
}

<style>
    .input-group-addon
    {
        padding:0 4px;
    }
    .form-control
    {
        padding:6px 6px;
    }
</style>

<div class="page-header">
    @if (Model.OrderId == -1)
    {
        <h1 class="page-title">Nueva Venta</h1>
        <div class="page-header-actions">
            
            <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
                <a href="javascript:void(0);" id="BalanceBtn" type="button" class="btn btn-default" target="_blank">
                    <i class="icon fa-money" aria-hidden="true"></i>
                    <span id="Balance" class="hidden-xs">CTA.CTE: --</span>
                </a>
            </div>

        </div>
    }
    else
    {
        <h1 class="page-title">Editar Venta - #@Model.OrderId.ToString()</h1>
    }
    

    </div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                   @using (Html.BeginForm("OrderUpdate", "Orders", FormMethod.Post, new { @class = "validation", @autocomplete = "off" }))
                    {
                        <div class="row">
                            <div class="form-group col-sm-2">
                                <label class="control-label">Fecha</label>
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="Date" value="@(Model.Created != DateTime.MinValue ? Model.Created.ToShortDateString() : DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                </div>
                            </div>
                            <div class="form-group col-sm-10">
                                <label class="control-label">Cliente</label>
                                <div style="display:flex;flex-direction:row;">
                                    <select class="form-control" name="CustomerId" id="CustomerId" @*data-plugin="select2"*@>
                                        @if (Model.Customer != null)
                                        {
                                            <option value="@Model.CustomerId" selected="selected">@Model.Customer.FullName</option>
                                        }
                                    </select>
                                    <a href="javascript:ShowCustomerModal()" style="padding:2px 10px; font-size:20px;" title="Nuevo Cliente">
                                        <i class="fa fa-plus-circle"></i></a>
                                </div>
                            </div>

                            <input type="hidden" name="PriceList" id="PriceListId" value="@Model.PriceList" />
                            <input type="hidden" name="UserType" id="UserType" value="@(Model.Customer != null ? Model.Customer.UserType.ToString() : string.Empty)" />
                            <input type="hidden" name="priceToUse" id="priceToUse" value="actual" />

                            @*<div class="form-group col-sm-2">
                                <label class="control-label">Lista de Precios</label>
                                <select class="form-control" name="PriceList" id="PriceListId" data-plugin="select2">
                                    <option value="@((int)PriceListEnum.Minorista)" selected="@(Model.PriceList == (int)PriceListEnum.Minorista)">Minorista</option>
                                    <option value="@((int)PriceListEnum.Mayorista)" selected="@(Model.PriceList == (int)PriceListEnum.Mayorista)">Mayorista</option>
                                    <option value="@((int)PriceListEnum.Distribuidor)" selected="@(Model.PriceList == (int)PriceListEnum.Distribuidor)">Distribuidor</option>
                                </select>
                            </div>

                            <div class="form-group col-sm-2">
                                <label class="control-label">Utilizar precio</label>
                                <select class="form-control" name="priceToUse" id="priceToUse" data-plugin="select2">
                                    <option value="actual">Precio actual</option>
                                    <option value="old">Precio anterior</option>
                                </select>
                                <input type="hidden" id="UserType" value="" />
                            </div>*@
                        </div>
                        <div class="row">
                            
                            <div class="form-group col-sm-3">
                                <label class="control-label">Canal</label>
                                <select class="form-control" name="Channel" id="Channel" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    <option value="@((int)OrderChannelEnum.SitioWeb)" selected="@((int)OrderChannelEnum.SitioWeb == Model.Channel)">Sitio Web</option>
                                    <option value="@((int)OrderChannelEnum.Telefono)" selected="@((int)OrderChannelEnum.Telefono == Model.Channel)">Telefono</option>
                                    <option value="@((int)OrderChannelEnum.WhatsApp)" selected="@((int)OrderChannelEnum.WhatsApp == Model.Channel)">WhatsApp</option>
                                </select>
                            </div>
                            <div class="form-group col-sm-3">
                                <label class="control-label">Forma de Pago</label>
                                <select class="form-control" name="PaymentMethodId" id="PaymentMethodId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    <option value="@((int)PaymentMethodEnum.MercadoPago)" selected="@((int)PaymentMethodEnum.MercadoPago == Model.PaymentMethodId)">Mercado Pago</option>
                                    <option value="@((int)PaymentMethodEnum.TransferenciaBancaria)" selected="@((int)PaymentMethodEnum.TransferenciaBancaria == Model.PaymentMethodId)">Transferencia Bancaria</option>
                                    <option value="@((int)PaymentMethodEnum.Efectivo)" selected="@((int)PaymentMethodEnum.Efectivo == Model.PaymentMethodId)">Efectivo en local</option>
                                </select>
                            </div>
                            <div class="form-group col-sm-3">
                                <label class="control-label">Forma de Entrega</label>
                                <select class="form-control" name="DeliveryMethodId" id="DeliveryMethodId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    <option value="@((int)DeliveryMethodEnum.RetiraLocal)" selected="@((int)DeliveryMethodEnum.RetiraLocal== Model.DeliveryMethodId)">Retira en local</option>
                                    <option value="@((int)DeliveryMethodEnum.Transporte)" selected="@((int)DeliveryMethodEnum.Transporte== Model.DeliveryMethodId)">Transporte</option>
                                    <option value="@((int)DeliveryMethodEnum.OcaPaP)" selected="@((int)DeliveryMethodEnum.OcaPaP== Model.DeliveryMethodId)">OCA - Domicilio</option>
                                    @*<option value="@((int)DeliveryMethodEnum.DomicilioCaba)" selected="@((int)DeliveryMethodEnum.DomicilioCaba == Model.DeliveryMethodId)">Envio a domicilio CABA</option>
        <option value="@((int)DeliveryMethodEnum.DomicilioGba)" selected="@((int)DeliveryMethodEnum.DomicilioGba == Model.DeliveryMethodId)">Envio a domicilio GBA</option>*@
                                </select>
                            </div>
                            @*<div class="form-group col-sm-2">
                                <label class="control-label">Costo de Entrega</label>
                                <div class="input-group">
                                    <span class="input-group-addon">$</span>
                                    <input type="text" class="form-control" name="ShippingCost" placeholder="0,00" value="@Model.ShippingCost">
                                </div>
                            </div>*@

                            <div class="form-group col-sm-3">
                                <label class="control-label">Estado</label>
                                <select class="form-control" name="OrderStatusId" id="OrderStatusId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    <option value="@((int)OrderStatusEnum.Confirmado)" selected="@((int)OrderStatusEnum.Confirmado == Model.OrderStatusId)">Confirmado</option>
                                    <option value="@((int)OrderStatusEnum.EnProceso)" selected="@((int)OrderStatusEnum.EnProceso == Model.OrderStatusId)">En Proceso</option>
                                    <option value="@((int)OrderStatusEnum.Cancelada)" selected="@((int)OrderStatusEnum.Cancelada == Model.OrderStatusId)">Cancelada</option>
                                </select>
                            </div>
                            @*<div class="form-group col-sm-2">
                                <label class="control-label">Vendedor</label>
                                <select class="form-control" id="SalerSelect" data-plugin="select2">
                                    @if (TempData["USERS"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["USERS"])
                                        {
                                            <option value="@item.Value" selected="@(item.Selected)">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>*@
                        </div>
                        <div class="form-group">
                            <label class="control-label">Observaciones</label>
                            <textarea class="form-control" name="Observations" rows="3">@(Model.Observations == null ? (Model.DeliveryMethodId == (int)DeliveryMethodEnum.OcaPaS ? "Sucursal de entrega: " + Model.DeliveryAddress : string.Empty) : Model.Observations)</textarea>
                        </div>
                        <div class="form-group hidden">
                            <label class="control-label">Usar tope de descuento</label>
                            <div class="input-group">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="UseMaxDiscount" id="UseMaxDiscount" class="js-switch-small form-control" data-plugin="switchery" data-size="small" data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-6">
                                    <h4>Detalle de la Compra</h4>
                                </div>
                                <div class="col-sm-6">
                                    <div class="text-right">
                                        <h4>Lista de Precios: <span id="PriceList">  @(Model.Customer != null ? ((PriceListEnum)Model.Customer.PriceList).ToString() : "- Ingrese un Cliente -")</span></h4>
                                        <input type="hidden" id="CustomerPriceList" value="@(Model.Customer != null ? Model.Customer.PriceList.ToString() : "1")" />
                                    </div>
                                </div>
                            </div>

                            <table class="table table-bordered table-hover table-striped" id="productsTable">
                                <thead>
                                    <tr>
                                        <th class="col-sm-3">Código de Producto</th>
                                        <th class="col-sm-1 text-center">Talle</th>
                                        <th class="col-sm-2 text-center">Color</th>
                                        <th class="text-center">Stock</th>
                                        <th class="col-sm-1 text-center">Cantidad</th>
                                        <th class="col-sm-2 text-center">Precio U.</th>
                                        <th class="col-sm-1 text-center">Des.(%)</th>
                                        <th class="col-sm-2 text-center">Total</th>
                                        <th class="col-sm-1 text-center"></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    
                                    @{int i = 1;}
                                    @foreach (var item in Model.OrderDetails)
                                    {
                                        <tr>
                                            <td>
                                                <select class="form-control" name="ProductId_@i" id="ProductId_@i" data-plugin="select2" onchange="GetSizes('@i');" style="max-width:400px !important;">
                                                    @if (TempData["Products"] != null)
                                                    {
                                                        var prod = ((SelectList)TempData["Products"]).FirstOrDefault(x => x.Value == item.ProductId.ToString());
                                                        <option value="@prod.Value" selected="selected">@prod.Text</option>
                                                    }
                                                </select>
                                            </td>
                                            <td>
                                                <select class="form-control" name="SizeId_@i" id="SizeId_@i" data-plugin="select2" onchange="GetColors('@i');" style="max-width:400px !important;">
                                                    @if (TempData["Sizes"] != null)
                                                    {
                                                        //var size = ((SelectList)TempData["Sizes"]).FirstOrDefault(x => x.Value == item.SizeId.ToString());
                                                        var availableSizes = item.Product.Stocks.Select(x => x.SizeId).ToList();
                                                        var sizes = ((SelectList)TempData["Sizes"]).Where(x => availableSizes.Contains(int.Parse(x.Value)));
                                                        foreach (var size in sizes)
                                                        {
                                                            <option value="@size.Value" @(size.Value == item.SizeId.ToString() ? "selected" : string.Empty)>@size.Text</option>

                                                        }
                                                    }
                                                </select>
                                            </td>
                                            <td>
                                                <select class="form-control" name="ColorId_@i" id="ColorId_@i" data-plugin="select2" onchange="GetStock('@i');" style="max-width:400px !important;">
                                                    @if (TempData["Colors"] != null)
                                                    {
                                                        //var color = ((SelectList)TempData["Colors"]).FirstOrDefault(x => x.Value == item.ColorId.ToString());
                                                        var availableColors = item.Product.Stocks.Select(x => x.ColorId).ToList();
                                                        var colors = ((SelectList)TempData["Colors"]).Where(x => availableColors.Contains(int.Parse(x.Value)));
                                                        foreach (var color in colors)
                                                        {
                                                            <option value="@color.Value" @(color.Value == item.ColorId.ToString() ? "selected" : string.Empty)>@color.Text</option>
                                                        }

                                                    }
                                                </select>
                                            </td>
                                            <td class="text-center" style="vertical-align:middle;" id="StockVirtual_@i">
                                                @{
                                                    var stock = stocks.FirstOrDefault(x => x.ProductId == item.ProductId && x.SizeId == item.SizeId && x.ColorId == item.ColorId);
                                                    var stockVirtual = stock != null ? stock.StockVirtual : 0;
                                                }
                                                @stockVirtual
                                            </td>
                                            <td>
                                                <input type="hidden" name="Stock_@i" value="@((stockVirtual + item.Quantity)  + "_" + item.Product.Code) ">
                                                <input type="hidden" name="OrderDetailId_@i" value="@item.OrderDetailId">
                                                <input type="hidden" id="MaxDiscount_@i" name="MaxDiscount_@i" value="@item.Product.MaxDiscount">
                                                <input type="text" name="Quantity_@i" id="Quantity_@i" class="form-control input-block text-right" value="@item.Quantity" onchange="setSubTotalItem('@i')" />
                                            </td>
                                            <td>
                                                <div class="input-group">
                                                    <span class="input-group-addon">$</span>
                                                    <input type="text" class="form-control text-right" name="Price_@i" id="Price_@i" placeholder="0,00" value="@string.Format("{0:0.00}",item.Price)" onchange="setSubTotalItem('@i')" >
                                                </div>
                                            </td>
                                            <td>
                                                <div class="input-group">
                                                    <span class="input-group-addon">%</span>
                                                    <input type="text" class="form-control text-right discount" name="Discount_@i" id="Discount_@i" placeholder="0,00" value="@item.Discount" onchange="setSubTotalItem('@i')" >
                                                </div>
                                            </td>
                                            <td class="Total">
                                                <div class="input-group">
                                                    <span class="input-group-addon">$</span>
                                                    <input type="text" class="form-control subtotal text-right" name="Subtotal_@i" id="Subtotal_@i" placeholder="0,00" value="@item.SubTotalWithDiscount" readonly>
                                                </div>
                                            </td>
                                            <td class="actions text-center vertical-align" style="vertical-align:middle;">
                                                <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-OrderDetailId="@item.OrderDetailId" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a>
                                            </td>
                                        </tr>
                                        i++;
                                    

                                        
                                        }
                                </tbody>
                                <tfoot>
                                    <tr class="active">
                                        <td>
                                            <button id="addToTable" class="btn btn-outline btn-primary" type="button">
                                                <i class="icon wb-plus" aria-hidden="true"></i> Agregar Producto
                                            </button>
                                        </td>
                                        <td class="text-right bold" colspan="6" style="font-weight:bold;vertical-align:middle;">SUBTOTAL</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="subtotal" id="subtotal" placeholder="0,00" value="" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="bold" style="font-weight:bold;display:flex;align-items:center;">                                               
                                            <div class="col-md-3">
                                                CUPÓN
                                            </div>
                                            <div class="col-md-9">
                                                <select class="form-control" name="CouponId" id="CouponId" data-plugin="select2" style="max-width:400px !important;">
                                                    @*@if (TempData["Coupons"] != null)
                                                    {
                                                        <option value="">- Seleccionar Cupón -</option>
                                                        foreach (var item in (SelectList)TempData["Coupons"])
                                                        {
                                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                                        }
                                                    }*@
                                                </select>

                                            </div>                              
                                        </td>
                                        <td class="text-right bold" colspan="5" style="font-weight:bold;vertical-align:middle;">DESCUENTO</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">%</span>
                                                <input type="text" class="form-control text-right" name="Discount_Percent" id="Discount_Percent" placeholder="0,00" value="@Model.Discount_Percent" onchange="setDiscount();">
                                            </div>
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="Discount" id="Discount" placeholder="0,00" value="@(string.Format("{0:n2}",Model.Discount))" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="6" style="font-weight:bold;vertical-align:middle;">IVA</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">%</span>
                                                <input type="text" class="form-control text-right" name="IVA_Percent" id="IVA_Percent" placeholder="0,00" value="@Model.IVA_Percent" onchange="setTaxes();">
                                            </div>
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right tax" name="IVA" id="IVA" placeholder="0,00" value="@Model.IVA" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="active">
                                        <td class="text-right bold" colspan="7" style="font-weight:bold;vertical-align:middle;">COSTO DE ENVÍO</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="ShippingCost" id="ShippingCost" placeholder="0,00" value="@(Model.ShippingCost.HasValue ? Model.ShippingCost.Value.ToString().Replace(",",".") : string.Empty)" onchange="setTotal();">
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td class="text-right bold" colspan="6" style="font-weight:bold;vertical-align:middle;">RECARGO (MP)</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">%</span>
                                                <input type="text" class="form-control text-right" name="Surcharge" id="Surcharge" placeholder="0,00" value="@Model.Surcharge" onchange="setTaxes();">
                                            </div>
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="SurchargeAmount" id="SurchargeAmount" placeholder="0,00" value="@Model.SurchargeAmount" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="active">
                                        <td class="text-right bold" colspan="7" style="font-weight:bold;vertical-align:middle;">TOTAL</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" name="Total" id="Total" placeholder="0,00" value="@string.Format("{0:0.00}",Model.Total)" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>

                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave" onclick="validarStock()">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Orders';">Cancelar</button>
                            @Html.HiddenFor(model => model.OrderId)
                            <input type="hidden" id="CurrencyId" name="CurrencyId" />
                            <input type="hidden" id="DeletedItems" name="DeletedItems" />
                            <input type="hidden" id="SalerId" name="SalerId" value="@Model.SalerId"/>
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

<!--NEW CUSTOMER MODAL DIALOG-->
<div class="modal fade" id="NewCustomer" aria-hidden="false" aria-labelledby="checks" role="dialog" tabindex="-1">
    <div class="modal-dialog">
        <form class="modal-content" id="modalCustomer" method="post" action="#" >
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Nuevo Cliente - Complete los datos</h4>
            </div>
            <div class="modal-body">
                @Html.Action("ModalCreateCustomer","Customers")
            </div>

        </form>
    </div>
</div>

<!--END NEW CUSTOMER MODAL DIALOG-->

<!-- Modal  RECEPTION DETAIL -->
<div class="modal fade" id="ModalDeliveryDetail" aria-hidden="false" aria-labelledby="ModalCustomerLabel" role="dialog" tabindex="-1">
    <div class="modal-dialog">
        <form class="modal-content" id="modalCustomer" method="post" action="#">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="ModalCustomerLabel">Detalle de Entrega</h4>
            </div>
            <div class="modal-body">
                <div class="row">
                    <div class="col-sm-12">
                        <div id="deliveryDetailDiv"></div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
<!-- End Modal -->




@section Scripts {
    
    <script src="~/Scripts/Orders/OrderUpdate.js"></script>
    <script type="text/javascript">


        $(document).ready(function ()
        {
            $("#CustomerId").select2({
                ajax: {
                    url: '/Customers/GetCustomersForSelect',
                    dataType: 'json'
                },
                placeholder: 'Ingrese el nombre del cliente',
                minimumInputLength: 3
            });

            $("#addToTable").click(function ()
            {
                if ($("#CustomerId").val() != '')
                {
                    var row_number = $("#productsTable tr").length;

                    var row = [
                        '<tr>',
                            '<td><select class="form-control" name="ProductId_' + row_number + '" id="ProductId_' + row_number + '" data-plugin="select2" onchange="GetSizes(' + row_number + ');"><option value=""></option></select></td>',
                            '<td><select class="form-control" name="SizeId_' + row_number + '" id="SizeId_' + row_number + '" data-plugin="select2" onchange="GetColors(' + row_number + ');"><option value=""></option></select></td>',
                            '<td><select class="form-control" name="ColorId_' + row_number + '" id="ColorId_' + row_number + '" data-plugin="select2" onchange="GetStock(' + row_number + ');"><option value=""></option></select></td>',
                            '<td class="text-center" style="vertical-align:middle;" id="StockVirtual_' + row_number + '"></td>',
                            '<td>',
                                '<input type="text" name="Quantity_' + row_number + '" id="Quantity_' + row_number + '" class="form-control input-block text-right" onchange="setSubTotalItem(' + row_number + ');" placeholder="0" />',
                                '<input type="hidden" name="OrderDetailId_' + row_number + '" value="-1">',
                                '<input type="hidden" id="MaxDiscount_' + row_number + '" name="MaxDiscount_' + row_number + '" value="">',
                            '</td>',
                            '<td><div class="input-group">',
                                '<span class="input-group-addon">$</span><input type="text" class="form-control text-right" name="Price_' + row_number + '" id="Price_' + row_number + '" placeholder="$0,00" value="" onchange="setSubTotalItem(' + row_number + ');" ></div>',
                            '</td>',
                            '<td class="Discount"><div class="input-group"><span class="input-group-addon">%</span><input type="text" class="form-control text-right discount" name="Discount_' + row_number + '" id="Discount_' + row_number + '" placeholder="0,00" onchange = "setSubTotalItem(' + row_number + ')" ></div></td>',
                            '<td class="Total"><div class="input-group"><span class="input-group-addon">$</span><input type="text" class="form-control text-right subtotal" name="Subtotal_' + row_number + '" id="Subtotal_' + row_number + '" placeholder="$0,00" readonly></div></td>',
                            '<td class="actions text-center vertical-align"><a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a>',
                            '<input type="hidden" id="Stock_' + row_number + '" name="Stock_' + row_number + '" /></td>',
                        '</tr>'
                    ].join(' ');

                    $("#productsTable").append(row);

                    var products = $("#ProductId_" + row_number);

                    GetProducts(products);

                    $("#ProductId_" + row_number).select2();
                    $("#SizeId_" + row_number).select2();
                    $("#ColorId_" + row_number).select2();
                }
                else
                {
                    toastr.warning("Primero debe seleccionar un Cliente.")
                }
            });

            $("#productsTable").on('click', '.remove-row', function ()
            {
                var item = $(this);
                var orderId = $("#OrderId").val();
                var orderDetailId = $(this).attr("data-OrderDetailId");

                if (orderId > 0 && orderDetailId > 0)
                {
                    $.ajax({
                        url: "/Orders/ValidateDeleteOrderDetail",
                        type: "GET",
                        data: { orderDetailId: orderDetailId},
                        success: function (data, textStatus, jqXHR)
                        {
                            if (data == '')
                            {
                                updateDeletedItems(orderDetailId)
                                item.parent().parent().remove();
                                setSubTotal();
                            }
                            else
                            {
                                toastr.warning("No es posible eliminar este Item, pertenece a la entrega #" + data);
                            }
                        },
                        error: function (request, status, error)
                        {
                            toastr.warning("Se produjo un error al interntar eliminar el Item seleccionado.");
                        }
                    });
                }
                else
                {
                    updateDeletedItems(orderDetailId)
                    item.parent().parent().remove();
                    setSubTotal();
                }
            });

            $("#CouponId").change(function () {
                var couponId = $(this).val();
                ApplyCoupon(couponId);
            });

            if ($("#OrderId").val() > 0)
                setSubTotal();

            $("#CustomerId").change(function ()
            {
                var customerId = $(this).val();

                if (customerId == "+")
                {
                    $("#NewCustomer").modal();
                }
                else
                {
                    if (customerId == '') {
                        $("#PriceList").text("- Ingrese un Cliente -")
                    }
                    else
                    {
                        GetCustomerPriceList(customerId);
                        UpdateCustomerBalanceButtons(customerId);
                    }
                }
            });

            if ("@Model.OrderId" != "-1")
                $("#CustomerId").change();

            //$("#PriceListId").change(function () {
            //    $("#PriceList").text($("#PriceListId option:selected").text());
                
            //});

            $("#UseMaxDiscount").change(function () {
                $(".discount").each(function () {
                    $(this).change();
                });
            });

            $("#SalerSelect").change(function () {
                $("#SalerId").val($(this).val());
            });
        });

        function ShowCustomerModal()
        {
            $("#NewCustomer").modal();
        }

        function validarStock() {
            //$.ajax({
            //    type: "POST",
            //    cache: false,
            //    url: "/Orders/ValidarStock",
            //    data: $(".validation").serializeArray(),
            //    async: false,
            //    success: function (data) {
            //        debugger;
            //        if (data.length > 0) {
            //            var msg = "Los siguientes productos no poseen stock suficiente: <br />";
            //            for (var i = 0; i < data.length; i++) {
            //                msg += data[i] + " <br />";
            //            }
            //            toastr.error(msg);
            //            event.preventDefault();
            //        }
            //    }
            //})
            var $form = $('.validation');

            var data = $form.serializeArray();
            $.ajax({
                type: "POST",
                cache: false,
                //url: rootPath + "/Orders/ValidarStock",
                url: "/Orders/ValidarStock",
                data: data,
                async: false,
                success: function (data) {
                    if (data.length > 0) {
                        var msg = "Alguno de los productos no tiene stock suficiente.";
                        //$('.js-quantity').removeClass('cart-table__quantity--unavailable');
                        //$('.cart-table__quantity-help').addClass('hidden');
                        for (var i = 0; i < data.length; i++) {
                            msg += data[i] + " <br />";
                        }
                        toastr.error(msg);
                        event.preventDefault();
                    }
                },
                error: function (a, b, c, d, e) {
                    debugger;
                }
            });
        }

        function updateDeletedItems(orderDetailId)
        {
            if (orderDetailId != "-1")
            {
                var ids = $("#DeletedItems").val();
                $("#DeletedItems").val(ids + orderDetailId + ",");
            }
        }

        function setSubTotalItem(row_number)
        {
            var price = $("#Price_" + row_number).val().replace(',', '.');
            var quantity = $("#Quantity_" + row_number).val().replace(',', '.');
            var discount = $("#Discount_" + row_number).val().replace(',', '.');
            var maxDiscount = $("#MaxDiscount_" + row_number).val().replace(',', '.');
            var useMaxDiscount = $('#UseMaxDiscount').is(':checked');

            if (price !== "" && quantity != "")
            {
                var subtotal = parseFloat(price) * parseFloat(quantity);

                var discount_val = 0;
                if (!useMaxDiscount || (discount != '' && discount > 0 && discount < maxDiscount))
                {
                    discount_val = subtotal * (discount / 100);
                    $("#Discount_" + row_number).css("box-shadow", "");
                    $("#Discount_" + row_number).css("border", "");
                }                    
                else
                {
                    if (discount != '' && discount > 0) {
                        discount_val = subtotal * (maxDiscount / 100);
                        $("#Discount_" + row_number).val(maxDiscount);
                        $("#Discount_" + row_number).css("box-shadow", "0 0 5px rgb(228, 21, 21)");
                        $("#Discount_" + row_number).css("border", "1px solid rgb(228, 21, 21)");
                    }                    
                }
                    
                subtotal = subtotal - discount_val;
                $("#Subtotal_" + row_number).val(subtotal.toFixed(2));

                setSubTotal();
            }
            else
                $("#Subtotal_" + row_number).val("")
        }

        function setSubTotal() {
            var subtotal = 0;
            $(".subtotal").each(function () {
                if ($(this).val().trim() != "")
                    subtotal += parseFloat($(this).val().replace(",", "."));
            });

            $("#subtotal").val(subtotal.toFixed(2));

            setDiscount();
        }

        function setDiscount() {
            var subtotal = parseFloat($("#subtotal").val()).toFixed(2);

            var discount_percent = $("#Discount_Percent").val().replace(',', '.').trim();
            if (discount_percent != "") {
                discount_percent = parseFloat(discount_percent);
                var discount = subtotal * discount_percent / 100;
                $("#Discount").val(discount.toFixed(2));
            }
            else
                $("#Discount").val("");
            setTaxes();
        }

        function setTaxes()
        {
            var subtotal = parseFloat($("#subtotal").val());

            var discount = 0;
            if ($("#Discount").val().trim() != '')
                discount = parseFloat($("#Discount").val());

            if (discount != NaN && discount != 0)
                subtotal = subtotal - discount;

            var iva_percent = $("#IVA_Percent").val().replace(",", ".").trim();
            var iva = 0;
            if (iva_percent != "")
            {
                iva_percent = parseFloat(iva_percent);
                iva = subtotal * iva_percent / 100;
                $("#IVA").val(iva.toFixed(2));
            }
            else
                $("#IVA").val("");


            setSurcharge();
            setTotal();
        }

        function setSurcharge() {
            var subtotal = parseFloat($("#subtotal").val());
            var surcharge = $("#Surcharge").val().replace(",", ".").trim();

            var discount = 0;
            if ($("#Discount").val().trim() != '')
                discount = parseFloat($("#Discount").val());

            if (discount != NaN && discount != 0)
                subtotal = subtotal - discount;

            var iva = 0;
            if ($("#IVA").val().trim() != '') {
                iva = parseFloat($("#IVA").val());
                subtotal = subtotal + iva;
            }

            if ($("#ShippingCost").val().trim() != "" && parseFloat($("#ShippingCost").val().replace(",", ".")) > 0) {
                subtotal += parseFloat($("#ShippingCost").val().replace(",", "."));
            }

            if (surcharge != "") {
                surcharge = parseFloat(surcharge);
                var surcharge_amount = subtotal * (surcharge / 100);
                $("#SurchargeAmount").val(surcharge_amount.toFixed(2));
            }
            else
                $("#SurchargeAmount").val("");
        }

        function setTotal()
        {
            var total = parseFloat($("#subtotal").val());

            $(".tax").each(function () {
                if ($(this).val().trim() != "")
                    total += parseFloat($(this).val());
            });

            if ($('#Discount').val().trim() != "") {
                total -= parseFloat($("#Discount").val());
            }

            if ($("#SurchargeAmount").val().trim() != "") {
                total += parseFloat($("#SurchargeAmount").val());
            }

            if ($("#ShippingCost").val().trim() != "" && parseFloat($("#ShippingCost").val().replace(",", ".")) > 0) {
                total += parseFloat($("#ShippingCost").val().replace(",", "."));
            }

            $("#Total").val(total.toFixed(2));
        }

        function GetProducts(control)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProductsToSale",
                data: $(this).serializeArray(),
                success: function (data)
                {
                    control.empty();
                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.ProductId + '>' + item.Code + ' - ' + item.Title + '</option>'));
                    });
                }
            });
        }

        function GetSizes(row_number)
        {
            if ($("#ProductId_" + row_number).val() != '')
            {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/Products/GetProductSizesToSale",
                    data: { ProductId: $("#ProductId_" + row_number).val() },
                    success: function (data)
                    {
                        control = $("#SizeId_" + row_number);
                        control.empty();
                        control.select2();
                        control.append($('<option value=""></option>'));

                        $.each(data, function (index, item) {
                            control.append($('<option value=' + item.SizeId + '>' + item.Description + '</option>'));
                        });

                        control = $("#ColorId_" + row_number);
                        control.empty();
                        control.select2();

                        cleanRowData(row_number);
                    }
                });
            }
            else
            {
                toastr.warning("Debe seleccionar un Producto.");
            }
        }

        function GetColors(row_number)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProductColorsToSale",
                data: { ProductId: $("#ProductId_" + row_number).val(), SizeId: $("#SizeId_" + row_number).val() },
                success: function (data)
                {
                    control = $("#ColorId_" + row_number);
                    control.empty();
                    control.select2();

                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.ColorId + '>' + item.Description + '</option>'));
                    });

                    cleanRowData(row_number);
                }
            });
        }

        function cleanRowData(row_number) {
            $("#StockVirtual_" + row_number).text('');
            $("#Stock_" + row_number).val('');
            $("#Price_" + row_number).val('');
            $("#MaxDiscount_" + row_number).val('');

            $("#Quantity_" + row_number).change();
        }


        var listProductos = [];
        function GetStock(row_number)
        {
            if ($("#ColorId_" + row_number).val() != '') {
                /*var listProductos = [];
                $("select:visible[id*='ProductId_']").each(function () {
                    listProductos.push(this.value);
                })*/
                /*var productId = $("#ProductId_" + row_number).val();
                var sizeId = $("#SizeId_" + row_number).val();
                var colorId = $("#ColorId_" + row_number).val();
    
                listProductos.push( productId + "-" + sizeId + "-" + colorId);*/

                if (!hasDuplicates(listProductos))
                {
                    $.ajax({
                        type: "GET",
                        cache: false,
                        url: "/Products/GetProductInfoToSale",
                        data: { ProductId: $("#ProductId_" + row_number).val(), SizeId: $("#SizeId_" + row_number).val(), ColorId: $("#ColorId_" + row_number).val(), PriceList: $("#PriceListId").val() },
                        success: function (data)
                        {
                            $("#StockVirtual_" + row_number).text(data.StockVirtual);
                            $("#Stock_" + row_number).val(data.StockVirtual + "_" + data.Code);
                            $("#MaxDiscount_" + row_number).val(data.MaxDiscount);

                            debugger;
                            if ($("#priceToUse").val() == "actual")
                                $("#Price_" + row_number).val(data.CustomerPrice.toFixed(2));
                            else
                                $("#Price_" + row_number).val(data.CustomerOldPrice.toFixed(2));

                            $("#Quantity_" + row_number).change();
                        }
                    });
                }
                else {
                    toastr.warning("Producto repetido.");
                    listProductos.pop();
                    cleanRowData(row_number);
                }
            }
            else
                cleanRowData(row_number);
        }

        function GetCustomerPriceList(customerId)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Orders/GetCustomerPriceList",
                data: { CustomerId: customerId },
                success: function (data)
                {
                    debugger;
                    $("#UserType").val(data.UserType);
                    $("#PriceList").text(data.Name)
                    $("#CustomerPriceList").val(data.PriceList);
                    $("#PriceListId").val(data.PriceList).trigger("change");
                    $("#CurrencyId").val(data.CurrencyId).change();
                }
            });
        }

        function UpdateCustomerBalanceButtons(customerId)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Orders/GetCustomerBalance",
                data: { CustomerId: customerId },
                success: function (data)
                {
                    if (data.Balance >= 0) {
                        $("#BalanceBtn").removeClass("btn-danger");
                        $("#BalanceBtn").addClass("btn-success");
                    } else {
                        $("#BalanceBtn").removeClass("btn-success");
                        $("#BalanceBtn").addClass("btn-danger");
                    }

                    $("#BalanceBtn").attr("href", "/CustomerAccounting?Id=" + customerId);
                    $("#Balance").text("SALDO: $" + data.Balance.toFixed(2));
                }
            });
        }

        function hasDuplicates(array)
        {
            var valuesSoFar = Object.create(null);
            for (var i = 0; i < array.length; ++i)
            {
                var value = array[i];
                if (value in valuesSoFar) {
                    return true;
                }
                valuesSoFar[value] = true;
            }
            return false;
        }

        function ApplyCoupon(couponId)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Orders/GetCoupon",
                data: { CouponId: couponId },
                success: function (data) {
                    if (data != "") {
                        $(".discount").each(function () {
                            $(this).val(data);
                            $(this).change();
                        });
                    }
                    
                }
            });
        }
    </script>


}

